
close all 

var
C_h C_s C_p K K_s K_p N_s N_p N Y Y_s Y_p Q_s Q_p I_s I_p I_sI_p G MPK_s MPK_p lambda_h X MU_s MU_b_s MU_p MU_b_p R_d R_l L L_s L_p L_cb A_s A_p i_d W_s W_p  D pi 
 TFP  theta_s theta_p govtc_obs gdp_obs nominaldepositrate_obs bankloanstotal_obs cpi_obs poegfcf_obs soegfcf_obs
; 

varexo
eps_A_s eps_A_p eps_G eps_L_cb eps_i_d eps_theta_s eps_theta_p
;
parameters
alpha phi  delta beta_h beta_s beta_p R_d_ss R_l_ss X_ss theta_s_ss theta_p_ss
MPK_s_ss MPK_p_ss I_sOY I_sOY_s I_pOY_p I_pOY L_pOY_p L_sOY_s C_sOY_s C_sOY C_pOY_p C_pOY C_l kappa_l L_ss kappa gamma_h gamma_s gamma_p  GOY C_hOY
rho_d phi_pi phi_Y rho_A_s rho_A_p rho_G rho_L_cb OMEGA_Q ita_n omega_n N_sON_p N_sON N_pON L_sOL MU_b_sOMU_s MU_b_pOMU_p ita Y_sOY K_sOK rho_theta_s rho_theta_p
;

alpha=0.4;
phi=1;
ita_n= 0.8; //AS in LIU(2016)
omega_n=0.5;    //AS IN LIU(2016)
delta=0.025;
beta_h=0.995;
beta_s=0.98;
beta_p=0.98;
R_d_ss = 1/beta_h;
R_l_ss = 1.01;
X_ss =1.1;
MU_b_sOMU_s = (1-beta_s * R_l_ss) /R_l_ss;
theta_s_ss=0.6;
MPK_s_ss = ((1- MU_b_sOMU_s * theta_s_ss)/beta_s) - (1-delta);
I_sOY_s = delta * alpha /(MPK_s_ss * X_ss);
L_sOY_s = (I_sOY_s/delta) * theta_s_ss / R_l_ss ;
C_sOY_s = alpha/X_ss - I_sOY_s + L_sOY_s - R_l_ss * L_sOY_s;

MU_b_pOMU_p = (1-beta_p * R_l_ss) /R_l_ss;
theta_p_ss=0.4;
MPK_p_ss = ((1- MU_b_pOMU_p * theta_p_ss)/beta_p) - (1-delta);
I_pOY_p = delta * alpha /(MPK_p_ss * X_ss);
L_pOY_p = (I_pOY_p/delta) * theta_p_ss / R_l_ss ;
C_pOY_p = alpha/X_ss - I_pOY_p + L_pOY_p - R_l_ss * L_pOY_p;

Y_sOY=0.5;
I_pOY = I_pOY_p * (1-Y_sOY);
I_sOY = I_sOY_s * Y_sOY;
C_pOY = C_pOY_p * (1-Y_sOY);
C_sOY = C_sOY_s * Y_sOY;

L_sOL = (L_sOY_s * Y_sOY)/(L_sOY_s * Y_sOY + L_pOY_p * (1-Y_sOY));

C_l =1;                         
kappa_l =5;                     
L_ss = (R_l_ss - R_d_ss/C_l);
theta=0.75;
kappa = ((1-theta)/theta)*(1-theta*beta_h);
gamma_h = 0.5; 
gamma_s = 0.5; 
gamma_p = 0.5;
GOY=0.3;
C_hOY = 1 - I_sOY - I_pOY-GOY -C_sOY-C_pOY;
rho_d=0.8;  
phi_pi=1.5;  
phi_Y=0.5;    
rho_A_s=0.8;    
rho_A_p=0.8;    
rho_G=0.8;    
rho_L_cb=0.7;   
rho_theta_s=0.7;
rho_theta_p=0.7;
OMEGA_Q= 0.2;   
ita_n=0.5;        

K_sOK= I_sOY/(I_pOY+I_pOY);
N_sON_p=1    ;
N_pON=(omega_n * N_sON_p^(1+ita_n) +(1-omega_n))^(-1/(1+ita_n)); 
N_sON=(omega_n + (1-omega_n)* N_sON_p^(-1-ita_n))^(-1/(1+ita_n));   
ita = 0.4;     



model(linear);

//household
-(C_h - gamma_h * C_h(-1)) + beta_h * gamma_h * (C_h(+1) - gamma_h * C_h) = (1-beta_h* gamma_h) * (1- gamma_h ) * lambda_h;

//(27)Optimazation between consumption and labor supply to soe, omega_n is the share of labor in soe
(phi - ita_n) * ((omega_n * N_sON_p^(1 + ita_n)) * N_s + (1-omega_n)*N_p ) / (omega_n*N_sON_p^(1 + ita_n) +(1-omega_n)) + ita_n * N_s  = lambda_h + W_s;

//(28)Optimazation between consumption and labor supply to poe
(phi - ita_n) * ((omega_n * N_sON_p^(1 + ita_n)) * N_s + (1-omega_n)*N_p ) / (omega_n*N_sON_p^(1 + ita_n) +(1-omega_n)) + ita_n * N_p  = lambda_h + W_p;

//(29)Optimazation between consumption and labor supply to poe
N = omega_n * N_sON * N_s +(1-omega_n) * N_pON * N_p;
 
lambda_h = lambda_h(+1) + R_d;
 


//banker
 R_l_ss *  R_l =  R_d_ss *  R_d + (C_l + kappa_l) * (R_l_ss - R_d_ss/C_l) * L - kappa_l * (R_l_ss - R_d_ss/C_l) * L_cb;
 
 L=D;
 
 L=L_sOL * L_s + (1-L_sOL) * L_p;
 
 //enterprenurer(state-owned)

-(C_s - gamma_s * C_s(-1)) + beta_s * gamma_s * (C_s(+1) - gamma_s * C_s) = (1-beta_s* gamma_s) * (1- gamma_s ) * MU_s;
 
 W_s= Y_s - N_s -X ;

 Q_s = OMEGA_Q * (I_s - I_s(-1)) - beta_s * OMEGA_Q * (I_s(+1) - I_s);
 
 Q_s+ MU_s = beta_s * MPK_s_ss * ( MU_s(+1) + MPK_s(+1)) + 
 beta_s * (1-delta) * (MU_s(+1) + Q_s(+1)) + MU_b_sOMU_s * theta_s_ss * (MU_s + Q_s(+1) + theta_s );
 
 MPK_s = Y_s -K_s(-1) -X;
 
 MU_s = beta_s * R_l_ss * (MU_s(+1)+R_l) +  MU_b_sOMU_s * R_l_ss * (MU_b_s + R_l);
 
 L_s + R_l = theta_s + Q_s(+1) + K_s;
 
 K_s = (1-delta)* K_s(-1) +delta * I_s;
 
 C_sOY_s * C_s + R_l_ss * L_sOY_s *(R_l(-1) + L_s(-1)) = (alpha/(1-ita)) * (Y_s-X) - I_sOY_s * I_s + L_sOY_s * L_s ;
 
 
Y_s= A_s+ alpha* K_s(-1) +(1-alpha)* N_s;

 
//enterprenurer(private-owned)

-(C_p - gamma_p * C_p(-1)) + beta_p * gamma_p * (C_p(+1) - gamma_p * C_p) = (1-beta_p* gamma_p) * (1- gamma_p ) * MU_p;
 
 W_p= Y_p - N_p -X ;

 Q_p = OMEGA_Q * (I_p - I_p(-1)) - beta_p * OMEGA_Q * (I_p(+1) - I_p);
 
 Q_p+ MU_p = beta_p * MPK_p_ss * ( MU_p(+1) + MPK_p(+1)) + 
 beta_p * (1-delta) * (MU_p(+1) + Q_p(+1)) + MU_b_pOMU_p * theta_p_ss * (MU_p + Q_p(+1) + theta_p);
 
 MPK_p = Y_p -K_p(-1) -X;
 
 MU_p = beta_p * R_l_ss * (MU_p(+1)+R_l) +  MU_b_pOMU_p * R_l_ss * (MU_b_p + R_l);
 
 L_p + R_l = theta_p + Q_p(+1) + K_p;
 
 K_p = (1-delta)* K_p(-1) +delta * I_p;
 
 C_pOY_p * C_s + R_l_ss * L_pOY_p *(R_l(-1) + L_p(-1)) = alpha * (Y_p-X) - I_pOY_p * I_p + L_pOY_p * L_p ;
 
 
  Y_p= A_p+ alpha* K_p(-1) +(1-alpha)* N_p;
 


Y=Y_sOY * Y_s + (1-Y_sOY) * Y_p;
 
Y= C_hOY * C_h + C_sOY * C_s + C_pOY * C_p + I_sOY * I_s +I_pOY * I_p + GOY *G;

K= K_sOK * K_s + (1-K_sOK) * K_p;

i_d =rho_d * i_d(-1) + (1-rho_d) * (phi_pi * pi + phi_Y * (Y-Y(-1))) +eps_i_d;

pi = beta_h * pi(+1) + kappa * (-X) ;

i_d = R_d + pi(+1) ;

//(36)TFP
TFP = Y - alpha * K(-1) - (1-alpha)* N;


I_sI_p = I_s - I_p;



//SHOCKS
A_s= rho_A_s * A_s(-1) +eps_A_s;
A_p= rho_A_p * A_p(-1) +eps_A_p;
G = rho_G * G(-1) +eps_G;
L_cb = rho_L_cb * L_cb(-1) + eps_L_cb;
theta_s = rho_theta_s * theta_s(-1) + eps_theta_s;
theta_p = rho_theta_p * theta_p(-1) + eps_theta_p;



govtc_obs =G;
gdp_obs=Y;
nominaldepositrate_obs=i_d;
bankloanstotal_obs=L;
cpi_obs= pi;
poegfcf_obs = I_p;
soegfcf_obs= I_s;

end;

shocks; 
var eps_i_d = 0.01^2;
var eps_A_s = 0.01^2 ;
var eps_A_p = 0.01^2;
var eps_G = 0.01^2;
var eps_L_cb = 0.01^2;
var eps_theta_s = 0.01^2;
var eps_theta_p = 0.01^2;
end;
steady;

check;
//(qz_zero_threshold=1e-20)

//stoch_simul(order = 2,irf=40,nocorr,nofunctions,nomoments);

//model_diagnostics(M_,options_,oo_),






estimated_params;
stderr eps_A_s,0.1,0.01,3,INV_GAMMA_PDF,0.01,2;
stderr eps_A_p,0.1,0.01,3,INV_GAMMA_PDF,0.01,2;
stderr eps_G,0.1,0.01,5,INV_GAMMA_PDF,0.01,2;
stderr eps_i_d,0.1,0.01,5,INV_GAMMA_PDF,0.01,2;
stderr eps_L_cb,0.1,0.01,5,INV_GAMMA_PDF,0.01,2;
stderr eps_theta_s,0.1,0.01,5,INV_GAMMA_PDF,0.01,2;
stderr eps_theta_p,0.1,0.01,5,INV_GAMMA_PDF,0.01,2;
rho_A_s,.5724,.01,.9999,BETA_PDF,0.7,0.20;
rho_A_p,.5724,.01,.9999,BETA_PDF,0.7,0.20;
rho_G,.3,.01,.9999,BETA_PDF,0.7,0.20;
rho_d,.3,.01,.9999,BETA_PDF,0.7,0.20;
rho_L_cb,.3,.01,.9999,BETA_PDF,0.7,0.20;
rho_theta_s,.3,.01,.9999,BETA_PDF,0.7,0.2;
rho_theta_p,.3,.01,.9999,BETA_PDF,0.7,0.2;
phi_pi,1.5,0.001,30,GAMMA_PDF,1.5,10;
phi_Y,.5,.01,.9999,BETA_PDF,0.5,0.2;
OMEGA_Q, 5,0.01,20,GAMMA_PDF,5,10;
//gamma_h,.5,.01,.9999,BETA_PDF,0.5,10;
//gamma_e,.5,.01,.9999,BETA_PDF,0.5,10;
kappa_l,5,0.001,20,GAMMA_PDF,5,10;




end;

varobs govtc_obs gdp_obs nominaldepositrate_obs bankloanstotal_obs  cpi_obs  poegfcf_obs  soegfcf_obs;
identification;
estimation(datafile=datafile_creditb,mode_check,mode_compute=4,lik_init=2,mh_replic=2000,mh_nblocks=2,presample = 3,mh_jscale=0.20,mh_drop=0.2,optim=('Display','iter','MaxFunEvals',1500),smoother)
//stoch_simul(order = 2,noprint,nocorr,nofunctions,nomoments);
shock_decomposition Y ;

